Page MenuHomePhabricator

Custom session handler corrupted by session_destroy, "Failed to initialize storage module"
Closed, ResolvedPublic

Description

Upstream fixed this in https://github.com/facebook/hhvm/issues/5072, we just need it on the cluster for T91699.

Event Timeline

Anomie created this task.Apr 30 2015, 6:07 PM
Anomie raised the priority of this task from to Needs Triage.
Anomie updated the task description. (Show Details)
Anomie added projects: acl*sre-team, HHVM.
Anomie added a subscriber: Anomie.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptApr 30 2015, 6:07 PM
bd808 added subscribers: Joe, bd808.May 11 2015, 5:17 PM

@Joe is this upstream patch by any chance in the latest HHVM builds you have been testing?

Joe added a comment.May 11 2015, 5:19 PM

Nope of course, but I guess we can add it to our next build. How serious is this?

Joe added a comment.May 11 2015, 5:24 PM

@bd808 @Anomie where did you see this error? which version of hhvm?

Already discussed on IRC, but for posterity: Error occurs on both mw1017 (3.6.1) and mw1050 (3.3.1) using either the test script in the upstream bug report or the following variant that uses SessionHandlerInterface:

<?php

echo PHP_VERSION . "\n";

// These implement a do-nothing session handler
class S implements SessionHandlerInterface {
	function open( $path, $name ){ return true; }
	function close(){ return true; }
	function read( $id ){ return ''; }
	function write( $id, $data ){ return true; }
	function destroy( $id ){ return true; }
	function gc( $t ){ return true; }
}

session_set_save_handler(new S(), true);

// Test
echo "start\n";

session_start();
session_destroy();
session_start();

echo "ok\n";
Dzahn triaged this task as High priority.May 26 2015, 9:54 PM
Dzahn added a subscriber: Dzahn.

@Joe do we have a "next HHVM build" tracking bug that we can attach this too so it doesn't get lost?

Restricted Application added a subscriber: Matanya. · View Herald TranscriptJun 30 2015, 11:20 PM
Joe claimed this task.Jul 21 2015, 3:22 PM
Joe set Security to None.
fgiunchedi lowered the priority of this task from High to Normal.Jul 21 2015, 3:28 PM
fgiunchedi added a subscriber: fgiunchedi.

Change 226286 had a related patch set uploaded (by Giuseppe Lavagetto):
Perserve session handler on session_destroy

https://gerrit.wikimedia.org/r/226286

Change 226286 merged by Giuseppe Lavagetto:
Perserve session handler on session_destroy

https://gerrit.wikimedia.org/r/226286

Anomie added a subscriber: hashar.Jul 22 2015, 4:41 PM

Testing on beta, it appears that (once deployed) the new package will fix this bug.

@hashar: Please upgrade the CI slaves with the new package from T106483, when it's ready.

Joe added a comment.Jul 23 2015, 7:55 AM

Canary appservers updated.

Testing on beta, it appears that (once deployed) the new package will fix this bug.
@hashar: Please upgrade the CI slaves with the new package from T106483, when it's ready.

Forked as T106699: Upgrade HHVM related packages on Trusty Jenkins slaves.

Joe added a comment.Jul 27 2015, 7:38 AM

All appservers upgraded. I'm resolving the ticket now, you can still reopen it later

Joe closed this task as Resolved.Jul 27 2015, 7:38 AM